#include "ikfksolver.h"

#define IKFKGoal_CLASS_ID	Class_ID(0x2fbb284c, 0x501a0ca0)


class IKFKGoal : public Control
{
	public:


		// Parameter block
		IParamBlock2	*pblock;	//ref 0
		IObjParam *ip;
		HWND hwnd;
		INode *InPosNode;
		INode *InVecNode;
		INode *OutPosNode;
		INode *OutVecNode;
		BOOL BezierComplete;
		Control *tales;

		Point3 preVal;


		//Animatable Methods
		//TCHAR *GetObjectName() { return GetString(IDS_CLASS_NAME); }
		Class_ID ClassID() {return IKFKGoal_CLASS_ID;}		
		SClass_ID SuperClassID() { return CTRL_POSITION_CLASS_ID; }
		void GetClassName(TSTR& s) {s = GetString(IDS_CLASS_NAME);}
		int NumSubs() { return 1;}
		Animatable* SubAnim(int i){return pblock;}
		TSTR SubAnimName(int i) {return GetString(IDS_PARAMS);}	
		int SubNumToRefNum(int subNum) { return subNum;}
		//BOOL AssignController(Animatable *control,int subAnim);

		//to display controller params on the motion panel 
		void BeginEditParams( IObjParam *ip, ULONG flags,Animatable *prev ); 
		// to undisplay 
		void EndEditParams( IObjParam *ip, ULONG flags,Animatable *next ); 
		// return number of ParamBlocks in this instance 
		int NumParamBlocks() {return 1;} // return i'th ParamBlock 
		IParamBlock2* GetParamBlock(int i) {return pblock;} 
		// return id'd ParamBlock 
		IParamBlock2* GetParamBlockByID(BlockID id) {if (pblock->ID()==id) return pblock;else return NULL;}

		//Reference Methods
		int NumRefs() {return 2;}
		RefTargetHandle GetReference(int i){
			if(i==0)
				return pblock;
			else
				return tales;
		}
		void SetReference(int i, RefTargetHandle rtarg);
		RefResult NotifyRefChanged(Interval changeInt, RefTargetHandle hTarget, 
			PartID& partID,  RefMessage message);
		IOResult Load(ILoad *iload) {return IO_OK;}
		IOResult Save(ISave *isave) {return IO_OK;}
		void RescaleWorldUnits(float f) {}

		//Control Methods
		void Copy(Control *from);
		RefTargetHandle Clone( RemapDir &remap );
		int IsKeyable(){return 0;}
		BOOL IsLeaf(){return FALSE;}
		void GetValue(TimeValue t, void *val, Interval &valid, GetSetMethod method = CTRL_ABSOLUTE );
		void SetValue(TimeValue t, void *val, int commit=1, GetSetMethod method= CTRL_ABSOLUTE);
		void CommitValue(TimeValue t);
		void RestoreValue(TimeValue t);
		int Display  (TimeValue t, INode *inode, ViewExp *vpt,int  flags);  


		//IKFKGoal Methods
		Point3 GetBezierValue (TimeValue t,float T);
		//Constructor/Destructor
		IKFKGoal(BOOL loading=FALSE);
		~IKFKGoal() {}
};

class IKFKGoalClassDesc : public ClassDesc2 
{

public:
	virtual int IsPublic() 							{ return TRUE; }
	virtual void* Create(BOOL loading) 		{return new IKFKGoal(loading); }
	void DeleteThis() { delete this; }
	virtual const TCHAR *	ClassName() 			{ return GetString(IDS_CLASS_NAME); }
	virtual SClass_ID SuperClassID() 				{ return CTRL_POSITION_CLASS_ID; }
	virtual Class_ID ClassID() 						{ return IKFKGoal_CLASS_ID; }
	virtual const TCHAR* Category() 				{ return _T(""); }

	virtual const TCHAR* InternalName() 			{ return _T("IKFKGoal"); }	// returns fixed parsable name (scripter-visible name)
	virtual HINSTANCE HInstance() 					{ return hInstance; }					// returns owning module handle
};